import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;

public class Bear extends Applet implements Runnable, MouseListener {

  private Point dest;
  private Thread anim;
  private Image bear, bearHappy, bearSad;
  private int bearX, bearY, height, width;
  private boolean applet=true;
  private Color bgcolor=new Color(0,170,170);
  
  public static void main(String[] args) {
    Frame f=new Frame("Bear");
    f.setSize(300,300);
    Bear b=new Bear();
    f.add(b);
    f.createImage(300,300);
    b.applet=false;
    b.init();
    f.setVisible(true);
  }

  public void init() {
   if (applet) {
     height=Integer.parseInt(getParameter("height"));
     width=Integer.parseInt(getParameter("width"));
     bearHappy=getImage(getCodeBase(),"bear_1.gif");
     bearSad=getImage(getCodeBase(),"bear_2.gif");
   } else {
     bearHappy=getToolkit().getImage("bear_1.gif");
     bearSad=getToolkit().getImage("bear_2.gif");
     height=300; width=300;
   }
   prepareImage(bearHappy,null);
   prepareImage(bearSad,null);
   addMouseListener(this);
   anim=new Thread(this);
   anim.start();
  }

  public void paint(Graphics g) {
    g.setColor(bgcolor);
    g.fillRect(0,0,width,height);
    if (bear!= null)  {
      g.drawImage(bear,
                  bearX,bearY,
                  bear.getWidth(null),bear.getHeight(null),
                  null);
    } 
  }

  public void update(Graphics g) {
    paint(g);
  }


  public void run(){
    bearX=height/2;
    bearY=width/2;
    while (true) {
      repaint();
      try{ Thread.sleep(25); } catch (Exception e){}
      if (bear != null) {
        if (dest == null) {
          try{ Thread.sleep(100); } catch (Exception e){}
          bearX+=(int)(12*Math.random()-6);
          bearY+=(int)(12*Math.random()-6);
        } else{
          if (bearX!= dest.x) bearX+=(bearX>dest.x)?-1:1;
          if (bearY!= dest.y) bearY+=(bearY>dest.y)?-1:1;
          if (bearX == dest.x && bearY == dest.y) dest=null; 
        }
      }
    }
  }

  public void mouseClicked(MouseEvent evt) {
    dest=evt.getPoint();
  }

  public void mousePressed(MouseEvent evt) { }

  public void mouseReleased(MouseEvent evt) { }

  public void mouseEntered(MouseEvent evt) {
    dest=evt.getPoint();
    bear=bearHappy; 
  }

  public void mouseExited(MouseEvent evt) {
    dest=evt.getPoint();
    bear=bearSad;
  } 

}

